# Wir berechnen die N-te partialsumme der geometrische Reihe


x=y=z=0;
b=0.5
N= 30;
for i=0:N
	x=x+b^i; # von kleinen Exponenten zu großen
        y=y+b^(N-i); # andersherum
        z=z+b^(N-i)-b^i; # und die Differenz (hier sollte am Ende 0 rauskommen)
endfor

printf("x=1+%f+...+%f^%i=%e\n",b,b, n,x);
printf("y=%f^%i+...+%f+1=%e\n",b,n,b,y);
printf("x-y(?)=(?)z=%e\n",z);


# Wenn wir die selbe Funktion nochmal woanders auswerten wollen, muessen wir nochmal die ganze Rechenvorschrift eingeben. In diesem Beispiel geht das gerade noch, aber was, wenns richtig aufwendig wird (zum Beispiel mit vielen Fallunterscheidungen?
# Das selbe  Problem tritt auf, wenn wir einen Algorithmus an zwei verschiedenen Stellen in unserem Programm verwenden wollen.
# Ausweg: Als "function" definieren

function x= reiheN(b,N)
  x=0;
  for i=0:N
    x+=b^i;
  endfor
endfunction

# jetzt koennen wir mit
# reiheN(b,N)
# wie oben ganz schnell eine Partialsumme berechnen

# ACHTUNG: Eine Funktion muss immer deklariert werden, bevor man sie verwenden kann! Der Interpreter abeitet sich schlieslich von vorne nach hinten und kennt weiter unten definierte Dinge noch nicht. 
# Allerdings kann eine Funktion Unterfunktionen haben, die erst nach der uebergeordneten Funktion definiert werden. Wichtig ist nur, dass alle Funktionen vor dem ersten Aufruf definiert werden.
# ACHTUNG: Die erste Zeile in einem Script darf nicht mit "function" beginnen! (Kommentare und Leerzeilen werden hierbei nicht beruecksichtigt). Deshalb wenns nicht anders geht eine Anweisung einfuegen die nicht stoert, zum Beispiel "2;"
# Bei laengeren Skripten mit vielen Funktionen stehen dann zu Anfang oft viele verschiedene Funktionen. Das wird unuebersichtlich! Ausweg: Funktionsdateien!
# Ein Beispiel ist "geom.m". Diese Datei sollte in eurem aktuellen Verzeichnis liegen.
# Alle Funktionen wie "norm", "sin", "log" usw. sind wie diese Datei aufgebaut.
# Am Anfang steht ein (optionaler) Kommentar der mit "help geom" abgerufen werden kann. (Syntax siehe Dokumentation)
# Hintergrund: Wenn Octave den Befehl NAME ausfuehren soll, so wird erstmal geprueft, ob es sich dabi um eine Variable handelt. Ist das nicht der Fall, wird nach einer Funktion gesucht, und zwar in der Datei NAME.m .
# Die Syntax ist genauso wie bei Funktionen in Skripten, nur das hier zusaetzlich noch ein hoffentlich hilfreicher Kommentar vorangestellt werden darf. Dieser wird dann durch den Befehl "help" abgerufen!

# "geom" sollte also genau das selbe Ergebnis wie "reiheN" liefern. Aber:
reiheN(b,N) == geom(b,N)
# liefert false.
# Grund?
# Wie groß ist der Fehler:
reiheN(b,N) - geom(b,N) 
# Interessant ist der Fehler in Abhaengigkeit von b und N.

#Mini-Aufgabe: b sei beliebig, aber fest. Berechne den Fehler der in der dritten Summation gemaess
# z=z+b^(N-i)-b^i
# entsteht in Abhaengigkeit von N

# Loesung: geomDifferenz.m

# Damit sind wir eigentlich schon fertig und ihr koennt loslegen!!
# Wenn ihr noch Fragen zur Syntax der Funktionsdeklaration habt, schaut mal in funktionen.m
